.\"
.\" %nmhwarning%
.\" $Id$
.\"
.\" include the -mh macro file
.so %etcdir%/tmac.h
.\"
.TH INC %manext1% MH.6.8 [%nmhversion%]
.SH NAME
inc \- incorporate new mail
.SH SYNOPSIS
.in +.5i
.ti -.5i
inc
\%[+folder]
\%[\-audit\ audit\-file] \%[\-noaudit]
\%[\-changecur]
.br
\%[\-nochangecur]
\%[\-form\ formatfile]
\%[\-format\ string]
.br
\%[\-file\ name]
\%[\-silent] \%[\-nosilent]
\%[\-truncate]
.br
\%[\-notruncate]
\%[\-width\ columns]
%nmhbeginpop%
\%[\-host\ hostname]
.br
\%[\-user\ username]
\%[\-pack\ file]
\%[\-nopack]
.br
%nmhendpop%
\%[\-version]
\%[\-help]
.in -.5i
.SH DESCRIPTION
\fIInc\fR incorporates mail from the user's incoming mail drop into
an \fInmh\fR folder.

You may specify which folder to use with `+folder'.  If no folder
is specified, then \fIinc\fR will use either the folder given by a
(non\-empty) \*(lqInbox:\*(rq entry in the user's profile, or the folder
named \*(lqinbox\*(rq.  If the specified (or default) folder doesn't
exist, the user will be queried prior to its creation.

When the new messages are incorporated into the folder, they are assigned
numbers starting with the next highest number for the folder.  As the
messages are processed, a \fIscan\fR listing of the new mail is produced.

If the user's profile contains a \*(lqMsg\-Protect: nnn\*(rq entry, it
will be used as the protection on the newly created messages, otherwise
the \fInmh\fR default of 0644 will be used.  For all subsequent operations
on these messages, this initially assigned protection will be preserved.

If the switch `\-audit\ audit\-file' is specified (usually as a default
switch in the profile), then \fIinc\fR will append a header line and a
line per message to the end of the specified audit\-file with the format:

.nf
.ti 1i
\*(<<inc\*(>> date
.ti 1.5i
<scan line for first message>
.ti 1.5i
<scan line for second message>
.ti 2.5i
<etc.>
.fi

This is useful for keeping track of volume and source of incoming mail.
Eventually, \fIrepl\fR, \fIforw\fR, \fIcomp\fR, and \fIdist\fR
may also produce audits to this (or another) file, perhaps with
\*(lqMessage\-Id:\*(rq information to keep an exact correspondence
history.  \*(lqAudit\-file\*(rq will be in the user's nmh directory unless
a full path is specified.

\fIInc\fR will incorporate even improperly formatted messages into the
user's nmh folder, inserting a blank line prior to the offending component
and printing a comment identifying the bad message.

In all cases, the user's mail drop will be zeroed, unless the
`\-notruncate' switch is given.

If the profile entry \*(lqUnseen\-Sequence\*(rq is present and non\-empty,
then \fIinc\fR will add each of the newly incorporated messages to
each sequence named by the profile entry.  \fIInc\fR will not zero each
sequence prior to adding messages.

The interpretation of the `\-form\ formatfile', `\-format\ string', and
`\-width\ columns' switches is the same as in \fIscan\fR\0(1).

By using the `\-file\ name' switch, one can direct \fIinc\fR to
incorporate messages from a file other than the user's maildrop.
Note that the name file will NOT be zeroed, unless the `\-truncate'
switch is given.

If the environment variable \fB$MAILDROP\fR is set, then \fIinc\fR
uses it as the location of the user's maildrop instead of the default
(the `-file\ name' switch still overrides this, however).  If this
environment variable is not set, then \fIinc\fR will consult the profile
entry \*(lqMailDrop\*(rq for this information.  If the value found is
not absolute, then it is interpreted relative to the user's \fInmh\fR
directory.  If the value is not found, then \fIinc\fR will look in the
standard system location for the user's maildrop.

The `\-silent' switch directs \fIinc\fR to be quiet and not ask any
questions at all.  This is useful for putting \fIinc\fR in the background
and going on to other things.
%nmhbeginpop%

\fIinc\fR will normally check local mail drops for mail, as given above.
But if the option \*(lqpophost:\*(rq is set in the mts configuration
file \*(lqmts.conf\*(rq, or if the `\-host\ hostname' switch is given,
then \fIinc\fR will query this POP service host for mail to incorporate.
If the `\-user\ username' switch is not given, then the current username
is used.

If \fIinc\fR uses POP, then the `\-pack\ file' switch is considered.
If given, then \fIinc\fR simply uses the POP to \fIpackf\fR\0(1) the
user's maildrop from the POP service host to the named file.  This switch
is provided for those users who prefer to use \fImsh\fR to read their
maildrops.

For debugging purposes, you may give the switch `\-snoop', which will
allow you to watch the POP transaction take place between you and the
POP server.
%nmhendpop%
.Fi
^$HOME/\&.mh\(ruprofile~^The user profile
^%etcdir%/mts.conf~^nmh mts configuration file
^%mailspool%/$USER~^Location of mail drop
.Pr
^Path:~^To determine the user's nmh directory
.Ps
^Alternate\-Mailboxes:~^To determine the user's mailboxes
.Ps
^Inbox:~^To determine the inbox, default \*(lqinbox\*(rq
.Ps
^Folder\-Protect:~^To set mode when creating a new folder
.Ps
^Msg\-Protect:~^To set mode when creating a new message and audit\-file
.Ps
^Unseen\-Sequence:~^To name sequences denoting unseen messages
.Sa
mhmail(1), scan(1), mh\-mail(5), post(8)
.De
`+folder' defaulted by \*(lqInbox\*(rq above
.Ds
`\-noaudit'
.Ds
`\-changecur'
.Ds
`\-format' defaulted as described above
.Ds
`\-nosilent'
.Ds
`\-truncate' if `\-file\ name' not given, `\-notruncate' otherwise
.Ds
`\-width' defaulted to the width of the terminal
%nmhbeginpop%
.Ds
`\-nopack'
%nmhendpop%
.Co
The folder into which messages are being incorporated will become the
current folder.  The first message incorporated will become the current
message, unless the `\-nochangecur' option is specified.  This leaves
the context ready for a \fIshow\fR of the first new message.
.Bu
The argument to the `\-format' switch must be interpreted as a single
token by the shell that invokes \fIinc\fR.  Therefore, one must usually
place the argument to this switch inside double\-quotes.
.En
